﻿Imports System.Net.Sockets
Imports System.Net
Imports System.Net.NetworkInformation
Imports System.Threading

Public Class Form1

   Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
      txtIP.Text = Dns.GetHostAddresses(My.Computer.Name).FirstOrDefault(
         Function(p) p.AddressFamily = Sockets.AddressFamily.InterNetwork).ToString & "/28"
      UpdateInfo()
   End Sub

   Private UpdateGui As Action(Of Boolean) = _
      Sub(enable As Boolean)
         Me.TableLayoutPanel1.Enabled = enable
         If Not enable Then UpdateInfo()
      End Sub

   Private Sub UpdateInfo()
      Dim ipData = New IPData With {.FullName = txtIP.Text}
      lbLBound.Text = ipData.LBound
      lbUBound.Text = ipData.UBound
      lbNetMask.Text = ipData.NetBitMask
      lbRangeLength.Text = ipData.Length.ToString
   End Sub

   Private Sub btStart_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btStart.Click
      UpdateGui(False)
      Array.ForEach({lstSuccess, lstFail}, Sub(lst) lst.Items.Clear())
      Dim ipData = New IPData With {.FullName = txtIP.Text}
      Dim threadCount = Integer.Parse(txtThreadCount.Text)
      Dim nIP = ipData.LBoundAddress - 1
      Dim ubound = nIP + ipData.Length
      Dim addSuccess = DirectCast(AddressOf lstSuccess.Items.Add, Action(Of String))
      Dim addFail = DirectCast(AddressOf lstFail.Items.Add, Action(Of String))
      Dim consume As ThreadStart = _
         Sub()
            Using _Ping = New Ping
               Do
                  Dim exceedsIpRange As Boolean
                  'exklusiv für diesen Thread nIP inkrementieren und gegen ubound checken
                  SyncLock Me
                     nIP += 1
                     exceedsIpRange = nIP > ubound
                  End SyncLock
                  If exceedsIpRange Then 'Thread läuft aus
                     'der letzte auslaufende Thread reEnabled das Gui
                     If nIP = ubound + threadCount Then Me.BeginInvoke(UpdateGui, True)
                     Exit Do
                  End If
                  'String-Darstellung von nIP pingen, Result-spezifisch adden
                  Dim sIP = ipData.Int2IP(nIP)
                  If _Ping.Send(sIP, 2000).Status = IPStatus.Success Then
                     Me.BeginInvoke(addSuccess, sIP)
                  Else
                     Me.BeginInvoke(addFail, sIP)
                  End If
               Loop
            End Using
         End Sub
      'viele Threads starten
      For i = 0 To threadCount - 1
         Call New Thread(consume) With {.Priority = ThreadPriority.Lowest}.Start()
      Next
   End Sub

   Private Sub btInfo_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btInfo.Click
      UpdateInfo()
   End Sub
End Class
